// Glasses -> ?
objTypes['circlelens_grin'] = {

  supportSurfaceMerging: false, //支援界面融合 Surface merging

  //建立物件 Create the obj
  create: function(mouse) {
	var p = "\\sqrt{2-\\frac{\\left(x^2+y^2\\right)}{100^2}}"
	var p_der_x = "-\\frac{x}{100^2\\cdot\\sqrt{2-\\frac{x^2+y^2}{100^2}}}"
	var p_der_y = "-\\frac{y}{100^2\\cdot\\sqrt{2-\\frac{x^2+y^2}{100^2}}}"
    return {type: 'circlelens_grin', p1: mouse, p2: mouse, p: p, p_der_x: p_der_x, p_der_y: p_der_y, fn_p: evaluateLatex(p) ,fn_p_der_x: evaluateLatex(p_der_x), fn_p_der_y: evaluateLatex(p_der_y), step_size: 1, eps: 1e-3};
  },

  p_box: objTypes['refractor'].p_box,

  //使用lineobj原型 Use the prototype lineobj
  c_mousedown: objTypes['lineobj'].c_mousedown,
  c_mousemove: function(obj, mouse, ctrl, shift) {objTypes['lineobj'].c_mousemove(obj, mouse, false, shift)},
  c_mouseup: objTypes['lineobj'].c_mouseup,
  move: objTypes['lineobj'].move,
  
  // Use the prototype circlelens
  clicked: objTypes['circlelens'].clicked,
  dragging: objTypes['circlelens'].dragging,
  getShotType: objTypes['circlelens'].getShotType,
  
  //判斷一道光是否會射到此物件(若是,則回傳交點) Test if a ray may shoot on this object (if yes, return the intersection)
  rayIntersection: function(obj, ray) {
	if (!obj.fn_p)
	{
		try {
		obj.fn_p = evaluateLatex(obj.p);
		obj.fn_p_der_x = evaluateLatex(obj.p_der_x);
		obj.fn_p_der_y = evaluateLatex(obj.p_der_y);
		} catch (e) {
		delete obj.fn_p;
		delete obj.fn_p_der_x;
		delete obj.fn_p_der_y;
		return;
		}
	}
	var R_squared = graphs.length_squared(obj.p1, obj.p2);
	if ( (graphs.length_squared(obj.p1, ray.p1) - R_squared - obj.eps < 0 && graphs.length_squared(obj.p1, ray.p1) - R_squared + obj.eps < 0) || (graphs.length_squared(obj.p1, ray.p1) - R_squared - obj.eps < 0 && graphs.length_squared(obj.p1, ray.p1) - R_squared + obj.eps > 0) ) // if the first point of the ray is inside the circle, or on its boundary
	{
		var len = graphs.length(ray.p1, ray.p2);
		var x = ray.p1.x + (obj.step_size / len) * (ray.p2.x - ray.p1.x)
		var y = ray.p1.y + (obj.step_size / len) * (ray.p2.y - ray.p1.y)
		intersection_point = graphs.point(x, y);
		if (graphs.length_squared(obj.p1, intersection_point) - R_squared - obj.eps < 0 && graphs.length_squared(obj.p1, intersection_point) - R_squared + obj.eps < 0) // if intersection_point is inside the circle
			return intersection_point;
	}
	return objTypes['circlelens'].rayIntersection(obj, ray);
  },

  zIndex: objTypes['refractor'].zIndex,

  //將物件畫到Canvas上 Draw the obj on canvas
  draw: function(obj, canvas, aboveLight) {

  ctx.beginPath();
  ctx.arc(obj.p1.x, obj.p1.y, graphs.length_segment(obj), 0, Math.PI * 2, false);
  objTypes['refractor'].fillGlass(2, obj, aboveLight);
  ctx.lineWidth = 1;
  //ctx.fillStyle="indigo";
  ctx.fillStyle = 'red';
  ctx.fillRect(obj.p1.x - 1.5, obj.p1.y - 1.5, 3, 3);
  //ctx.fillStyle="rgb(255,0,255)";
  if (obj == mouseObj) {
    ctx.fillStyle = 'magenta';
    //ctx.fillStyle="Purple";
    ctx.fillRect(obj.p2.x - 1.5, obj.p2.y - 1.5, 3, 3);
  }


  },

  //當物件被光射到時 When the obj is shot by a ray
  shot: function(obj, ray, rayIndex, rp, surfaceMerging_objs) {
	var R_squared = graphs.length_squared(obj.p1, obj.p2)
	if ( ( (graphs.length_squared(obj.p1, ray.p1) - R_squared - obj.eps > 0 && graphs.length_squared(obj.p1, ray.p1) - R_squared + obj.eps > 0) || (graphs.length_squared(obj.p1, ray.p1) - R_squared - obj.eps < 0 && graphs.length_squared(obj.p1, ray.p1) - R_squared + obj.eps < 0) ) && graphs.length_squared(obj.p1, rp) - R_squared - obj.eps < 0 && graphs.length_squared(obj.p1, rp) - R_squared + obj.eps > 0 ) // if the ray is hitting the circle from the outside, or from the inside (meaning that the point rp is on the boundary of the circle, and the point ray.p1 is inside/outside the circle)
	{
		var p = obj.fn_p({x: rp.x - obj.p1.x, y: rp.y - obj.p1.y}) // refractive index at the intersection point - rp
		objTypes['circlelens'].shot({type: 'circlelens', p1: obj.p1, p2: obj.p2, p: p}, ray, rayIndex, rp, surfaceMerging_objs)
	}
	else
	{
		next_point = objTypes['circlelens_grin'].step(obj, ray.p1, rp);
		ray.p1 = rp;
		ray.p2 = next_point;
	}

  },
  
  // Receives an instance of the circlelens_grin object, and two points inside this lens, and returns the next point to where the ray, connecting these two points, will travel, based on the ray trajectory equation (equation 11.1 in the cited text below)
  step: function(obj, p1, p2) {
	// using Euler's method to solve the ray trajectory equation (based on sections 11.1 and 11.2, in the following text: https://sci-hub.ru/10.1007/BFb0012092)
	// x_der_s and x_der_s_prev are the x-coordinate derivatives with respect to the arc-length parameterization, at two different points (similarly for y_der_s and y_der_s_prev)
	var len = graphs.length(p1, p2)
	var x = p2.x - obj.p1.x;
	var y = p2.y - obj.p1.y;
	var x_der_s_prev = (p2.x - p1.x) / len;
	var y_der_s_prev = Math.sign(p2.y - p1.y) * Math.sqrt(1 - x_der_s_prev*x_der_s_prev);
		
	var x_der_s = x_der_s_prev + obj.step_size * (obj.fn_p_der_x({x: x, y: y}) * (1 - x_der_s_prev**2) - obj.fn_p_der_y({x: x, y: y}) * x_der_s_prev * y_der_s_prev) / obj.fn_p({x: x, y: y});
	var y_der_s = y_der_s_prev + obj.step_size * (obj.fn_p_der_y({x: x, y: y}) * (1 - y_der_s_prev**2) - obj.fn_p_der_x({x: x, y: y}) * x_der_s_prev * y_der_s_prev) / obj.fn_p({x: x, y: y});
		
	var x_new = obj.p1.x + x + obj.step_size * x_der_s;
	var y_new = obj.p1.y + y + obj.step_size * y_der_s;
		
	return graphs.point(x_new, y_new);
  }
  
};
